import java.util.ArrayList;

public class User {

    /*
    Class to represent a User, includes the User's name and a record of which
    lessons, quizzes and scores they have completed.
     */

    private String username;
    private ArrayList<Lesson> userRecord;

    public User(String username) {
        this.username = username;
        this.userRecord = new ArrayList<>();
    }

    // GETTER METHODS

    public String getUsername() {
        return username;
    }

    public ArrayList<Lesson> getUserRecord() {
        return userRecord;
    }
     // END GETTER METHODS

    // CUSTOM METHODS

    /**
     * Checks the Users record to see if they have already completed the lesson and/or quiz for that Lesson
     * object. If not then their record is updated to show what they have done for that Lesson.
     * @param currentLesson
     */
    public void addToUserRecord(Lesson currentLesson) {
        boolean inUserRecord = false;
        int lessonsPlaceInRecord = 0;

        // Check to see if currentLesson is in the user record already
        for(int i = 0; i < userRecord.size(); i++) {
            if(userRecord.get(i).getLessonTitle().equals(currentLesson.getLessonTitle())){
                inUserRecord = true;
                lessonsPlaceInRecord = i;
            }
        }

        // Update or create the lesson in the user record
        if(inUserRecord) {
            userRecord.get(lessonsPlaceInRecord).setQuizScore(currentLesson.getQuizScore());
        } else {
            userRecord.add(currentLesson);
        }
    }
}
