public class Module {

    /*
    This class holds the lesson objects and enables the user to pick from them. It has been designed so that it
    can be replicated and reused to add a Courses class to the program. This is expanded upon in the ReadMe.
     */

    private Lesson[] lessons;

    public Module(Lesson[] lessons) {
        this.lessons = lessons;
    }

    // GETTER METHODS

    /**
     * Returns a lesson from the Lesson array depending on User input
     * User starts choice at 1 rather than 0 so this needs to be translated to arrays with base 0
     * @param choice
     * @return Lesson object from array at choice - 1
     */
    public Lesson getLesson(int choice) {
        return lessons[choice - 1];
    }

    // Rather than have a getter and then call .length on it, it has been combined here for readability.
    public int getLessonsArrayLength() {
        return lessons.length;
    }
    // END GETTER METHODS

    /**
     * Loops through the array printing out each lesson
     * Also prints out the user instruction based on the number of lessons in the module
     */
    public void listAll()  {
        // Lesson Menu Title
        System.out.println("  + ------------------------------------------------ +");
        System.out.println(" +  |                   LESSONS                    |  +");
        System.out.println("  + ------------------------------------------------ +");

        System.out.println("      Please pick from one of the lessons below: ");
        System.out.println(" ");

        // Empty Strings declared which will be used to build the userInstruction string
        String userInstruction = "";
        String numberToChooseLesson = "";

        /* Loops through the lesson array printing out the titles along with a lesson number
        that users can to press to access their chosen lesson
        */
        for(int i = 0; i < lessons.length; i++) {
            System.out.println("[" + (i + 1) + "] " + lessons[i].getLessonTitle());

            /* If it is the last lesson to add to the userInstruction String then the String needs to
               include the closing bracket
            */
            if(i != lessons.length - 1) {
                numberToChooseLesson = (i + 1) + ", ";
            } else {
                numberToChooseLesson = (i + 1) + "):";
            }
            userInstruction = userInstruction + numberToChooseLesson;
        }
        System.out.println("By pressing the corresponding number (" + userInstruction);
    };
}
